\ ceForth_23, 13jul17cht
( cEFa.F, 10sep09cht, for c_eFORTH )
( Copyrighted by Offete Enterprises, 2009 ,All rights reserved )
( ceForth_21, 21jun17cht, clean up )

( IO )
:: ?KEY  ?RX ;;
:: KEY   BEGIN ?RX UNTIL ;;      
:: EMIT  TX! ;;

CRR .( Common functions ) CRR
:: WITHIN ( u ul uh -- t ) \ ul <= u < uh
   OVER - >R - R> U< ;;
:: >CHAR ( c -- c )
  $7F LIT AND DUP $7F LIT BL WITHIN
  IF DROP ( CHAR _ ) $5F LIT THEN ;;
:: ALIGNED ( b -- a ) 3 LIT + FFFFFFFC LIT AND ;;
:: HERE ( -- a ) CP @ ;;
:: PAD ( -- a ) HERE 50 LIT + ;;
:: TIB ( -- a ) 'TIB @ ;;

CRR
:: @EXECUTE ( a -- ) @ ?DUP IF EXECUTE THEN ;;
:: CMOVE ( b b u -- )
   FOR AFT OVER C@ OVER C! >R 1+ R> 1+ THEN NEXT 2DROP ;;
:: MOVE ( b b u -- )
   CELL/ FOR AFT OVER @ OVER ! >R CELL+ R> CELL+ THEN NEXT 2DROP ;;
:: FILL ( b u c -- )
  SWAP FOR SWAP AFT 2DUP C! 1+ THEN NEXT 2DROP ;;

CRR .( Numeric Output ) CRR \ single precision
:: DIGIT ( u -- c )
  9 LIT OVER < 7 LIT AND +
  ( CHAR 0 ) 30 LIT + 
;;
:: EXTRACT ( n base -- n c )
  0 LIT SWAP UM/MOD SWAP DIGIT ;;
:: <# ( -- ) PAD HLD ! ;;
:: HOLD ( c -- ) HLD @ 1- DUP HLD ! C!  ;;
:: # ( u -- u ) BASE @ EXTRACT HOLD ;;
:: #S ( u -- 0 ) BEGIN # DUP WHILE REPEAT ;;
CRR
:: SIGN ( n -- ) 0< IF ( CHAR - ) 2D LIT HOLD THEN ;;
:: #> ( w -- b u ) DROP HLD @ PAD OVER - ;;
:: str ( n -- b u ) DUP >R ABS <# #S R> SIGN #> ;;
:: HEX ( -- ) 10 LIT BASE ! ;;
:: DECIMAL ( -- ) 0A LIT BASE ! ;;

CRR .( Numeric Input ) CRR \ single precision
:: wupper ( w -- w' ) \ convert 4 byte in the word to uppercase
        5F5F5F5F LIT AND  ;;
:: >upper ( c -- UC ) dup 61 LIT 7B LIT WITHIN IF 5F LIT AND THEN ;;
                
:: DIGIT? ( c base -- u t )
  >R ( CHAR 0 ) >upper 30 LIT - 9 LIT OVER <
  IF 7 LIT - DUP 0A LIT  < OR THEN DUP R> U< ;;
:: NUMBER? ( a -- n T | a F )
  BASE @ >R  0 LIT OVER COUNT ( a 0 b n)
  OVER c@ ( CHAR $ ) 24 LIT =
  IF HEX SWAP 1+ SWAP 1- THEN ( a 0 b' n')
  OVER c@ ( CHAR - ) 2D LIT = >R ( a 0 b n)
  SWAP R@ - SWAP R@ + ( a 0 b" n") ?DUP
  IF 1- ( a 0 b n) 
    FOR DUP >R c@ BASE @ DIGIT? 
      WHILE SWAP BASE @ * +  R> 1+ 
    NEXT DROP R@ ( b ?sign) IF NEGATE THEN SWAP 
      ELSE R> R> ( b index) 2DROP ( digit number) 2DROP 0 LIT 
      THEN DUP 
  THEN R> ( n ?sign) 2DROP R> BASE ! ;; 

CRR .( Basic I/O ) CRR
:: SPACE ( -- ) BL EMIT ;;
:: CHARS ( +n c -- )
  SWAP 0 LIT MAX
  FOR AFT DUP EMIT THEN NEXT DROP ;;
:: SPACES ( +n -- ) BL CHARS ;;
:: TYPE ( B U -- )
  FOR AFT COUNT >CHAR EMIT THEN NEXT DROP ;;
:: CR ( -- ) ( =CR ) 0A LIT 0D LIT EMIT EMIT ;;
:: do$ ( -- $adr )
  R> R@ R> COUNT + ALIGNED >R SWAP >R ;; 

CRR
:: $"| ( -- a ) do$ ;; 
:: ."| ( -- ) do$ COUNT TYPE ;;
::  .R ( n +n -- )
  >R str R> OVER - SPACES TYPE ;;
:: U.R ( u +n -- )
  >R <# #S #> R> OVER - SPACES TYPE ;;
:: U. ( u -- ) <# #S #> SPACE TYPE ;;
::  . ( n -- )
  BASE @ 0A LIT  XOR
  IF U. EXIT THEN str SPACE TYPE ;;
:: ? ( a -- ) @ . ;;

CRR .( Parsing ) CRR
:: (parse) ( b u c -- b u delta ; <string> )
  tmp c! OVER >R DUP \ b u u
  IF 1- tmp c@ BL =
    IF              \ b u' \ 'skip'
      FOR BL OVER c@ - 0< NOT
        WHILE 1+
      NEXT ( b) R> DROP 0 LIT DUP EXIT \ all delim
        THEN  R>
    THEN OVER SWAP  \ b' b' u' \ 'scan'
    FOR tmp c@ OVER c@ -  tmp c@ BL =
      IF 0< THEN WHILE 1+
    NEXT DUP >R
      ELSE R> DROP DUP 1+ >R
      THEN OVER -  R>  R> - EXIT
  THEN ( b u) OVER R> - ;;

:: PACK$ ( b u a -- a ) \ always word-aligned
  DUP >R 
  2DUP + $FFFFFFFC LIT AND 0 LIT SWAP ! \ LAST WORD FILL 0 1ST
  2DUP C! 1+ SWAP CMOVE  R> ;;

:: PARSE ( c -- b u ; <string> )
  >R  TIB >IN @ +
  #TIB @ >IN @ -
  R> (parse) >IN +! ;;
:: TOKEN ( -- a ;; <string> ) 
  BL PARSE $1F LIT MIN
  HERE CELL+         \ S D N 
  PACK$  
  ;;
:: WORD ( c -- a ; <string> )
  PARSE HERE CELL+ PACK$ ;; \ BM+
  
CRR .( Dictionary Search ) CRR
:: NAME> ( a -- xt ) COUNT 1F LIT AND + ALIGNED ;;
:: SAME? ( a a c-c-c-u -- a a f \ -0+ )
 $1F LIT AND CELL/ 
 FOR AFT OVER R@ CELLS + @ wupper
   OVER R@ CELLS + @ wupper 
   - ?DUP
   IF R> DROP EXIT THEN
 THEN NEXT
 0 LIT ;;

:: find ( a va -- xt na | a 0 )
  SWAP         \ va a
  DUP @ tmp !  \ va a  \ get cell count
  DUP @ >R     \ va a  \ #XOR --- count and 1st 3 char
  cell+ SWAP   \ a' va  a'=a(#XOR)+4
  BEGIN @ DUP  \ a' na na
    IF DUP @ $FFFFFF3F LIT AND wupper
      R@ wupper XOR \ ignore lexicon bits
      IF   cell+ -1 LIT
      ELSE cell+ tmp @ SAME?
      THEN
    ELSE R> DROP SWAP cell- SWAP EXIT \ a 0
    THEN
  WHILE cell- cell-  \ a' la
  REPEAT R> DROP SWAP DROP
  cell- DUP NAME> SWAP ;;
:: NAME? ( a -- cfa na | a 0 )
   CONTEXT find ;;

CRR .( Terminal ) CRR
:: ^H ( b b b -- b b b ) \ backspace
  >R OVER R> SWAP OVER XOR
  IF ( =BkSp ) 8 LIT EMIT
     1-         BL EMIT \ distructive
     ( =BkSp ) 8 LIT EMIT \ backspace
  THEN ;;
:: TAP ( bot eot cur c -- bot eot cur )
  DUP EMIT OVER C! 1+ ;;
:: kTAP ( bot eot cur c -- bot eot cur )
  DUP ( =Cr ) 0D LIT XOR
  OVER ( =Lf ) 0A LIT XOR AND
  IF ( =BkSp ) 8 LIT XOR
    IF BL TAP ELSE ^H THEN
    EXIT
  THEN DROP SWAP DROP DUP  ;;

CRR
:: ACCEPT ( b u -- b u )
  OVER + OVER
  BEGIN 2DUP XOR
  WHILE  KEY  DUP BL -  5F LIT U<
    IF TAP ELSE kTAP THEN
  REPEAT DROP  OVER -
 ;;
:: EXPECT ( b u -- ) ACCEPT SPAN ! DROP ;;
:: QUERY ( -- )
  TIB 50 LIT ACCEPT #TIB !
  DROP 0 LIT >IN ! ;;

CRR .( Error handling ) CRR
:: ABORT ( -- ) 'ABORT @EXECUTE
:: abort"| ( f -- )
  IF do$ COUNT TYPE ABORT THEN do$ DROP ;;
:: ERROR ( a -- ) 
  space count type $3F LIT EMIT
  $1B LIT ( ESC) EMIT
  CR ABORT

CRR .( Interpret ) CRR
:: $INTERPRET ( a -- )
  NAME? ?DUP
  IF C@ $40 LIT AND
    abort"| $LIT  compile only" EXECUTE  EXIT
  THEN 
  NUMBER? IF EXIT ELSE ERROR THEN 
      
:: [ ( -- )  DOLIT $INTERPRET 'EVAL ! ;; IMMEDIATE
:: .OK ( -- ) CR
  DOLIT $INTERPRET 'EVAL @ =
  IF >R >R >R DUP . R> DUP . R> DUP . R> DUP . ."| $LIT  ok>" 
  THEN ;;
:: EVAL ( -- )
  BEGIN TOKEN DUP @
  WHILE 'EVAL  @EXECUTE \ ?STACK
  REPEAT DROP .OK ;;

CRR .( Shell ) CRR
:: QUIT ( -- )
  ( =TIB) $100 LIT 'TIB ! [ BEGIN QUERY EVAL AGAIN

:: , ( w -- )  HERE DUP CELL+ CP ! ! ;;
:: LITERAL ( n -- ) DOLIT DOLIT , , ;; IMMEDIATE 
:: ALLOT ( n -- ) ALIGNED CP +! ;;
:: $," ( -- ) ( CHAR " ) 22 LIT WORD COUNT + ALIGNED CP ! ;;

CRR .( Name Compiler ) CRR

:: ?UNIQUE ( a -- a )
  DUP NAME? 
  ?DUP IF COUNT 1F LIT AND SPACE TYPE ."| $LIT  reDef "
  THEN DROP ;;
:: $,n ( a -- )
  DUP @ IF ?UNIQUE
    ( na ) DUP NAME> CP ! 
    ( na ) DUP LAST ! \ for OVERT
    ( na ) CELL-
    ( la ) CONTEXT @ SWAP ! EXIT
  THEN ERROR

CRR .( Compiler Primitives ) CRR

:: ' ( -- xt )
  TOKEN NAME? IF EXIT THEN
  ERROR
:: [COMPILE] ( -- ; <string> )
  '  , ;; IMMEDIATE
:: COMPILE ( -- ) R> DUP @ , CELL+ >R ;;

CRR .( FORTH Compiler ) CRR

:: $COMPILE ( a -- )
  NAME? ?DUP
  IF @ $80 LIT AND
    IF EXECUTE
    ELSE ,
    THEN EXIT
  THEN  
  NUMBER?
  IF LITERAL EXIT
  THEN ERROR
  
:: OVERT ( -- ) LAST @ CONTEXT ! ;; 
:: ] ( -- ) DOLIT $COMPILE 'EVAL ! ;;
:: : ( -- ; <string> ) TOKEN $,n ] 6 LIT , ;;
:: ; ( -- ) DOLIT EXIT , [ OVERT  ;; IMMEDIATE

CRR .( Tools ) CRR
:: dm+ ( b u -- b )
  OVER 6 LIT U.R 
  FOR AFT DUP @ 9 LIT U.R CELL+
  THEN NEXT ;;
:: DUMP ( b u -- )
  BASE @ >R HEX  1F LIT + 20 LIT /
  FOR AFT CR 8 LIT 2DUP dm+
  >R SPACE CELLS TYPE R>
  THEN NEXT DROP R> BASE ! ;;

CRR
:: >NAME ( xt -- na | F )
  CONTEXT
  BEGIN @ DUP
  WHILE 2DUP NAME> XOR
    IF 1-
    ELSE SWAP DROP EXIT
    THEN
  REPEAT SWAP DROP ;;
:: .ID ( a -- )
  COUNT $01F LIT AND TYPE SPACE ;;

:: WORDS ( -- )
  CR CONTEXT
  0 LIT TMP !
  BEGIN @ ?DUP
  WHILE DUP SPACE  .ID CELL-
    TMP @ $0A LIT <
    IF 1 LIT TMP +!
    ELSE CR 0 LIT TMP ! THEN
  REPEAT ;;

:: FORGET ( -- )
  TOKEN NAME? ?DUP
  IF CELL- DUP CP ! 
     @ DUP CONTEXT ! LAST !
     DROP EXIT
  THEN ERROR

CRR

:: COLD ( -- )
  CR ."| $LIT eForth in C, Ver 2.3, 2017 " CR
  QUIT 
    
CRR .( Structures ) CRR
:: THEN ( A -- ) HERE SWAP ! ;; IMMEDIATE
:: FOR ( -- a ) COMPILE >R HERE ;; IMMEDIATE
:: BEGIN ( -- a ) HERE ;; IMMEDIATE
CRR
:: NEXT ( a -- )  COMPILE DONEXT , ;; IMMEDIATE
:: UNTIL ( a -- ) COMPILE QBRANCH , ;; IMMEDIATE
:: AGAIN ( a -- ) COMPILE BRANCH , ;; IMMEDIATE
:: IF ( -- A )   COMPILE QBRANCH HERE 0 LIT , ;; IMMEDIATE
:: AHEAD ( -- A ) COMPILE BRANCH HERE 0 LIT , ;; IMMEDIATE
CRR
:: REPEAT ( A a -- ) AGAIN THEN ;; IMMEDIATE
:: AFT ( a -- a A ) DROP AHEAD HERE SWAP ;; IMMEDIATE
:: ELSE ( A -- A )  AHEAD SWAP THEN ;; IMMEDIATE
:: WHEN ( a A -- a A a ) IF OVER ;; IMMEDIATE
:: WHILE ( a -- A a )    IF SWAP ;; IMMEDIATE

CRR
:: ABORT" ( -- ; <string> ) DOLIT abort"| HERE ! $," ;; IMMEDIATE
:: $" ( -- ; <string> ) DOLIT $"| HERE ! $," ;; IMMEDIATE
:: ." ( -- ; <string> ) DOLIT ."| HERE ! $," ;; IMMEDIATE

CRR
:: CODE ( -- ; <string> ) TOKEN $,n OVERT ;;
:: CREATE ( -- ; <string> ) CODE $203D LIT , ;;
:: VARIABLE ( -- ; <string> ) CREATE 0 LIT , ;;
:: CONSTANT CODE $2004  LIT , , ;;

CRR
(makeHead) .( ( -- ) dolist, aanew 29 LIT PARSE TYPE ;; IMMEDIATE
(makeHead) \ ( -- )  dolist, aanew $A LIT WORD DROP  ;; IMMEDIATE 
(makeHead) ( dolist, aanew 29 LIT PARSE 2DROP ;;        IMMEDIATE
(makeHead) COMPILE-ONLY dolist, aanew $40 LIT LAST @ +! ;;
(makeHead) IMMEDIATE dolist, aanew $80 LIT LAST @ +! ;;

CRR

