\ ceForth_23, 13jul17cht
( cefMEATa.F, 10sep09cht, e_eForth Project )

HEX
variable debugging?
\ -1 debugging? !

: .head ( addr -- addr )
   SPACE >IN @ 20 WORD COUNT TYPE >IN !
   DUP . 
   ;

: CR CR
   debugging? @
   IF .S KEY 0D = IF ." DONE" QUIT THEN
   THEN
   ;

: BREAK CR
   .S KEY 0D = IF ." DONE" QUIT THEN
   ;

: forth_dup DUP ;
: forth_drop DROP ;
: forth_over OVER ;
: forth_swap SWAP ;
: forth_@ @ ;
: forth_forget FORGET ;
: CRR cr ;

CREATE ram  8000 ALLOT
: RESET   ram 8000 0 FILL ;   RESET
: RAM@    ram +  @ ;
: RAMC@   ram +  C@ ;
: RAM!    ram +  ! ;
: RAMC!   ram +  C! ;

: FOUR   (  a -- ) 4 FOR AFT  DUP RAM@ 9 U.R  4 + THEN NEXT  ;
: SHOW ( a)   10 FOR AFT  CR  DUP 7 .R SPACE
      FOUR SPACE FOUR  THEN NEXT ;
: showram 0 0C FOR AFT SHOW THEN NEXT DROP ;

VARIABLE hFile
CREATE CRLF-ARRAY 0D C, 0A C,
: CRLF   
      hFile @ 
      CRLF-ARRAY 2
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   ;

: open-mif-file
   Z" rom_23.h"
   $40000000 ( GENERIC_WRITE )
   0 ( share mode )
   0 ( security attribute )
   2 ( CREATE_ALWAYS )
   $80 ( FILE_ATTRIBUTE_NORMAL )
   0 ( hTemplateFile )
   CreateFileA hFile !
   ;
: write-mif-header
   CRLF
      hFile @ 
      $" long data[4096] = {" 
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   ;
: write-mif-trailer
   CRLF
      hFile @ 
      $" } ; " 
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   ;
: write-mif-data
   0 ( initial ram location )
   $1000 FOR AFT
      CRLF
      hFile @ 
      OVER ( 4 / )  ( byte address )
      <# 2F HOLD 2A HOLD 20 HOLD 
          7 FOR # NEXT 
      20 HOLD 2A HOLD 2F HOLD #>
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
      hFile @ 
      OVER ram@ 
      <# 2C HOLD 7 FOR # NEXT 78 HOLD 30 HOLD 20 HOLD #>
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
      CELL+
   THEN NEXT
   DROP ( discard ram location )
   ;

: close-mif-file
   hFile @ CloseHandle DROP
   ;

: write-mif-file
   open-mif-file
   write-mif-header
   write-mif-data
   write-mif-trailer
   close-mif-file
   ;
   
CR .( include assembler )
FLOAD cefASMa_23.f

$200 ORG
CR .( include kernel )
FLOAD cefKERNa_23.f

CRR .( include eforth ) 
FLOAD cEFa_23.f
H forth_@

CRR
0 ORG 
dolist, aanew
COLD

$90 ORG $100                             #, 
$94 ORG $10                              #, 
$98 ORG lastH forth_@                    #, 
$9C ORG                                  #, 
$A0 ORG lastH forth_@                    #, 
$A4 ORG $INTERPRET                        
$A8 ORG QUIT                                   
$AC ORG 0                                #, 

write-mif-file
FLOAD cefSIMa_23.F